class ISO8601Basic::Date < ::Date

  def self.new(*args)
    case value = args[0]
    when Numeric then super
    when String
      dt = ::Date.iso8601 value
      super dt.year, dt.month, dt.day
    else super end
  end

  def +(other)
    case other
    when ISO8601Basic::Time
      ISO8601Basic::DateTime.new year, month, day,
        other.hour, other.minute, other.second, other.zone
    when ISO8601Basic::Duration
      { years: [:>>, 12], months: [:>>, 1], weeks: [:+, 7], days: [:+, 1] }.reduce self do |date, (key, (action, factor))|
        date.send action, other.to_h[key] * factor
      end
    else super end
  end

  def inspect
    "#<ISO8601Basic::Date: #{iso8601}>"
  end
end